<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for application/routes.py: 31%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">
<div id="header">
    <div class="content">
        <h1>Coverage for <b>application/routes.py</b> :
            <span class="pc_cov">31%</span>
        </h1>
        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />
        <h2 class="stats">
            115 statements &nbsp;
            <span class="run shortkey_r button_toggle_run">36 run</span>
            <span class="mis show_mis shortkey_m button_toggle_mis">79 missing</span>
            <span class="exc show_exc shortkey_x button_toggle_exc">0 excluded</span>
        </h2>
    </div>
</div>
<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>
<div id="source">
    <p id="t1" class="run"><span class="n"><a href="#t1">1</a></span><span class="t"><span class="key">from</span> <span class="nam">flask</span> <span class="key">import</span> <span class="nam">abort</span>&nbsp;</span><span class="r"></span></p>
    <p id="t2" class="run"><span class="n"><a href="#t2">2</a></span><span class="t"><span class="key">from</span> <span class="nam">flask</span> <span class="key">import</span> <span class="nam">current_app</span> <span class="key">as</span> <span class="nam">app</span>&nbsp;</span><span class="r"></span></p>
    <p id="t3" class="run"><span class="n"><a href="#t3">3</a></span><span class="t"><span class="key">from</span> <span class="nam">flask</span> <span class="key">import</span> <span class="nam">jsonify</span><span class="op">,</span> <span class="nam">request</span>&nbsp;</span><span class="r"></span></p>
    <p id="t4" class="run"><span class="n"><a href="#t4">4</a></span><span class="t"><span class="key">from</span> <span class="nam">jwt</span> <span class="key">import</span> <span class="nam">DecodeError</span><span class="op">,</span> <span class="nam">ExpiredSignatureError</span>&nbsp;</span><span class="r"></span></p>
    <p id="t5" class="run"><span class="n"><a href="#t5">5</a></span><span class="t"><span class="key">from</span> <span class="nam">werkzeug</span><span class="op">.</span><span class="nam">exceptions</span> <span class="key">import</span> <span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t6" class="pln"><span class="n"><a href="#t6">6</a></span><span class="t">    <span class="nam">BadRequest</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t7" class="pln"><span class="n"><a href="#t7">7</a></span><span class="t">    <span class="nam">InternalServerError</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t8" class="pln"><span class="n"><a href="#t8">8</a></span><span class="t">    <span class="nam">NotFound</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t9" class="pln"><span class="n"><a href="#t9">9</a></span><span class="t">    <span class="nam">ServiceUnavailable</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t10" class="pln"><span class="n"><a href="#t10">10</a></span><span class="t">    <span class="nam">Unauthorized</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t11" class="pln"><span class="n"><a href="#t11">11</a></span><span class="t">    <span class="nam">UnsupportedMediaType</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t12" class="pln"><span class="n"><a href="#t12">12</a></span><span class="t"><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t13" class="pln"><span class="n"><a href="#t13">13</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t14" class="run"><span class="n"><a href="#t14">14</a></span><span class="t"><span class="key">from</span> <span class="nam">utils</span><span class="op">.</span><span class="nam">BLConsul</span> <span class="key">import</span> <span class="nam">BLConsul</span>&nbsp;</span><span class="r"></span></p>
    <p id="t15" class="run"><span class="n"><a href="#t15">15</a></span><span class="t"><span class="key">from</span> <span class="nam">utils</span><span class="op">.</span><span class="nam">config</span> <span class="key">import</span> <span class="nam">DevelopmentConfig</span> <span class="key">as</span> <span class="nam">Config</span>&nbsp;</span><span class="r"></span></p>
    <p id="t16" class="run"><span class="n"><a href="#t16">16</a></span><span class="t"><span class="key">from</span> <span class="nam">utils</span><span class="op">.</span><span class="nam">logger</span> <span class="key">import</span> <span class="nam">Logger</span>&nbsp;</span><span class="r"></span></p>
    <p id="t17" class="pln"><span class="n"><a href="#t17">17</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t18" class="run"><span class="n"><a href="#t18">18</a></span><span class="t"><span class="key">from</span> <span class="op">.</span><span class="nam">api_client</span> <span class="key">import</span> <span class="nam">update_order</span>&nbsp;</span><span class="r"></span></p>
    <p id="t19" class="run"><span class="n"><a href="#t19">19</a></span><span class="t"><span class="key">from</span> <span class="op">.</span><span class="nam">businessLogic</span> <span class="key">import</span> <span class="nam">BusinessLogic</span>&nbsp;</span><span class="r"></span></p>
    <p id="t20" class="run"><span class="n"><a href="#t20">20</a></span><span class="t"><span class="key">from</span> <span class="op">.</span><span class="nam">models</span> <span class="key">import</span> <span class="nam">Delivery</span>&nbsp;</span><span class="r"></span></p>
    <p id="t21" class="pln"><span class="n"><a href="#t21">21</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t22" class="run"><span class="n"><a href="#t22">22</a></span><span class="t"><span class="nam">logger</span> <span class="op">=</span> <span class="nam">Logger</span><span class="op">(</span><span class="str">"routes"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t23" class="pln"><span class="n"><a href="#t23">23</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t24" class="run"><span class="n"><a href="#t24">24</a></span><span class="t"><span class="nam">config</span> <span class="op">=</span> <span class="nam">Config</span><span class="op">.</span><span class="nam">get_instance</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t25" class="run"><span class="n"><a href="#t25">25</a></span><span class="t"><span class="nam">bl_consul</span> <span class="op">=</span> <span class="nam">BLConsul</span><span class="op">.</span><span class="nam">get_instance</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t26" class="pln"><span class="n"><a href="#t26">26</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t27" class="pln"><span class="n"><a href="#t27">27</a></span><span class="t"><span class="com"># Delivery Routes ####################################################################################################</span>&nbsp;</span><span class="r"></span></p>
    <p id="t28" class="run"><span class="n"><a href="#t28">28</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">"/{}/create"</span><span class="op">.</span><span class="nam">format</span><span class="op">(</span><span class="nam">config</span><span class="op">.</span><span class="nam">SERVICE_NAME</span><span class="op">)</span><span class="op">,</span> <span class="nam">methods</span><span class="op">=</span><span class="op">[</span><span class="str">"POST"</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t29" class="pln"><span class="n"><a href="#t29">29</a></span><span class="t"><span class="key">def</span> <span class="nam">create_delivery</span><span class="op">(</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t30" class="run"><span class="n"><a href="#t30">30</a></span><span class="t">    <span class="key">try</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t31" class="run"><span class="n"><a href="#t31">31</a></span><span class="t">        <span class="nam">auth_header</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">headers</span><span class="op">[</span><span class="str">"Authorization"</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t32" class="pln"><span class="n"><a href="#t32">32</a></span><span class="t">        <span class="com"># decoded_token = BusinessLogic.get_instance().decrypt_jwt(auth_header)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t33" class="run"><span class="n"><a href="#t33">33</a></span><span class="t">        <span class="nam">decoded_token</span> <span class="op">=</span> <span class="nam">BusinessLogic</span><span class="op">.</span><span class="nam">static_decrypt_jwt</span><span class="op">(</span><span class="nam">auth_header</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t34" class="run"><span class="n"><a href="#t34">34</a></span><span class="t">        <span class="key">if</span> <span class="str">"C_DELIVERY"</span> <span class="key">in</span> <span class="nam">decoded_token</span><span class="op">[</span><span class="str">"perms"</span><span class="op">]</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t35" class="run"><span class="n"><a href="#t35">35</a></span><span class="t">            <span class="key">if</span> <span class="nam">request</span><span class="op">.</span><span class="nam">headers</span><span class="op">[</span><span class="str">"Content-Type"</span><span class="op">]</span> <span class="op">!=</span> <span class="str">"application/json"</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t36" class="mis show_mis"><span class="n"><a href="#t36">36</a></span><span class="t">                <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t37" class="pln"><span class="n"><a href="#t37">37</a></span><span class="t">                    <span class="nam">msg</span><span class="op">=</span><span class="str">"Unsupported media type in create_delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span>&nbsp;</span><span class="r"></span></p>
    <p id="t38" class="pln"><span class="n"><a href="#t38">38</a></span><span class="t">                <span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t39" class="mis show_mis"><span class="n"><a href="#t39">39</a></span><span class="t">                <span class="nam">abort</span><span class="op">(</span><span class="nam">UnsupportedMediaType</span><span class="op">.</span><span class="nam">code</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t40" class="run"><span class="n"><a href="#t40">40</a></span><span class="t">            <span class="nam">content</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">json</span>&nbsp;</span><span class="r"></span></p>
    <p id="t41" class="pln"><span class="n"><a href="#t41">41</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t42" class="run"><span class="n"><a href="#t42">42</a></span><span class="t">            <span class="nam">new_delivery_dict</span> <span class="op">=</span> <span class="nam">BusinessLogic</span><span class="op">.</span><span class="nam">get_instance</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">create_delivery</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t43" class="pln"><span class="n"><a href="#t43">43</a></span><span class="t">                <span class="nam">order_id</span><span class="op">=</span><span class="nam">content</span><span class="op">[</span><span class="str">"order_id"</span><span class="op">]</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t44" class="pln"><span class="n"><a href="#t44">44</a></span><span class="t">                <span class="nam">user_id</span><span class="op">=</span><span class="nam">content</span><span class="op">[</span><span class="str">"user_id"</span><span class="op">]</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t45" class="pln"><span class="n"><a href="#t45">45</a></span><span class="t">                <span class="nam">address</span><span class="op">=</span><span class="nam">content</span><span class="op">[</span><span class="str">"address"</span><span class="op">]</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t46" class="pln"><span class="n"><a href="#t46">46</a></span><span class="t">            <span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t47" class="run"><span class="n"><a href="#t47">47</a></span><span class="t">            <span class="key">if</span> <span class="nam">new_delivery_dict</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t48" class="mis show_mis"><span class="n"><a href="#t48">48</a></span><span class="t">                <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span><span class="nam">msg</span><span class="op">=</span><span class="str">" Not found in create_delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t49" class="mis show_mis"><span class="n"><a href="#t49">49</a></span><span class="t">                <span class="nam">abort</span><span class="op">(</span><span class="nam">NotFound</span><span class="op">.</span><span class="nam">code</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t50" class="pln"><span class="n"><a href="#t50">50</a></span><span class="t">            <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t51" class="run"><span class="n"><a href="#t51">51</a></span><span class="t">                <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span><span class="nam">msg</span><span class="op">=</span><span class="str">"POST /delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">DEBUG</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t52" class="run"><span class="n"><a href="#t52">52</a></span><span class="t">                <span class="nam">response</span> <span class="op">=</span> <span class="nam">jsonify</span><span class="op">(</span><span class="nam">new_delivery_dict</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t53" class="run"><span class="n"><a href="#t53">53</a></span><span class="t">            <span class="key">return</span> <span class="nam">response</span>&nbsp;</span><span class="r"></span></p>
    <p id="t54" class="pln"><span class="n"><a href="#t54">54</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t55" class="mis show_mis"><span class="n"><a href="#t55">55</a></span><span class="t">            <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t56" class="pln"><span class="n"><a href="#t56">56</a></span><span class="t">                <span class="nam">msg</span><span class="op">=</span><span class="str">"Not enough permissions in create_delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span>&nbsp;</span><span class="r"></span></p>
    <p id="t57" class="pln"><span class="n"><a href="#t57">57</a></span><span class="t">            <span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t58" class="mis show_mis"><span class="n"><a href="#t58">58</a></span><span class="t">            <span class="nam">abort</span><span class="op">(</span><span class="nam">Unauthorized</span><span class="op">.</span><span class="nam">code</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t59" class="mis show_mis"><span class="n"><a href="#t59">59</a></span><span class="t">    <span class="key">except</span> <span class="op">(</span><span class="nam">KeyError</span><span class="op">,</span> <span class="nam">DecodeError</span><span class="op">,</span> <span class="nam">ExpiredSignatureError</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t60" class="mis show_mis"><span class="n"><a href="#t60">60</a></span><span class="t">        <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span><span class="nam">msg</span><span class="op">=</span><span class="str">"Token error in create_delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t61" class="mis show_mis"><span class="n"><a href="#t61">61</a></span><span class="t">        <span class="nam">abort</span><span class="op">(</span><span class="nam">Unauthorized</span><span class="op">.</span><span class="nam">code</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t62" class="pln"><span class="n"><a href="#t62">62</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t63" class="pln"><span class="n"><a href="#t63">63</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t64" class="run"><span class="n"><a href="#t64">64</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">"/{}/&lt;int:delivery_id>"</span><span class="op">.</span><span class="nam">format</span><span class="op">(</span><span class="nam">config</span><span class="op">.</span><span class="nam">SERVICE_NAME</span><span class="op">)</span><span class="op">,</span> <span class="nam">methods</span><span class="op">=</span><span class="op">[</span><span class="str">"GET"</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t65" class="pln"><span class="n"><a href="#t65">65</a></span><span class="t"><span class="key">def</span> <span class="nam">view_delivery</span><span class="op">(</span><span class="nam">delivery_id</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t66" class="mis show_mis"><span class="n"><a href="#t66">66</a></span><span class="t">    <span class="key">try</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t67" class="mis show_mis"><span class="n"><a href="#t67">67</a></span><span class="t">        <span class="nam">auth_header</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">headers</span><span class="op">[</span><span class="str">"Authorization"</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t68" class="mis show_mis"><span class="n"><a href="#t68">68</a></span><span class="t">        <span class="nam">decoded_token</span> <span class="op">=</span> <span class="nam">BusinessLogic</span><span class="op">.</span><span class="nam">get_instance</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">decrypt_jwt</span><span class="op">(</span><span class="nam">auth_header</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t69" class="mis show_mis"><span class="n"><a href="#t69">69</a></span><span class="t">        <span class="key">if</span> <span class="str">"R_DELIVERY"</span> <span class="key">in</span> <span class="nam">decoded_token</span><span class="op">[</span><span class="str">"perms"</span><span class="op">]</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t70" class="mis show_mis"><span class="n"><a href="#t70">70</a></span><span class="t">            <span class="nam">delivery</span> <span class="op">=</span> <span class="nam">BusinessLogic</span><span class="op">.</span><span class="nam">get_instance</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">get_delivery</span><span class="op">(</span><span class="nam">delivery_id</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t71" class="mis show_mis"><span class="n"><a href="#t71">71</a></span><span class="t">            <span class="key">if</span> <span class="nam">delivery</span><span class="op">.</span><span class="nam">user_id</span> <span class="op">!=</span> <span class="nam">decoded_token</span><span class="op">[</span><span class="str">"sub"</span><span class="op">]</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t72" class="mis show_mis"><span class="n"><a href="#t72">72</a></span><span class="t">                <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t73" class="pln"><span class="n"><a href="#t73">73</a></span><span class="t">                    <span class="nam">msg</span><span class="op">=</span><span class="str">"Impersonation attempt in view_delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span>&nbsp;</span><span class="r"></span></p>
    <p id="t74" class="pln"><span class="n"><a href="#t74">74</a></span><span class="t">                <span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t75" class="mis show_mis"><span class="n"><a href="#t75">75</a></span><span class="t">                <span class="nam">abort</span><span class="op">(</span><span class="nam">Unauthorized</span><span class="op">.</span><span class="nam">code</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t76" class="mis show_mis"><span class="n"><a href="#t76">76</a></span><span class="t">            <span class="key">if</span> <span class="nam">delivery</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t77" class="mis show_mis"><span class="n"><a href="#t77">77</a></span><span class="t">                <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span><span class="nam">msg</span><span class="op">=</span><span class="str">"Not found in view_delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t78" class="mis show_mis"><span class="n"><a href="#t78">78</a></span><span class="t">                <span class="nam">abort</span><span class="op">(</span><span class="nam">NotFound</span><span class="op">.</span><span class="nam">code</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t79" class="mis show_mis"><span class="n"><a href="#t79">79</a></span><span class="t">            <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span><span class="nam">msg</span><span class="op">=</span><span class="str">"GET /delivery/&lt;int:delivery_id>"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">DEBUG</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t80" class="mis show_mis"><span class="n"><a href="#t80">80</a></span><span class="t">            <span class="nam">response</span> <span class="op">=</span> <span class="nam">jsonify</span><span class="op">(</span><span class="nam">delivery</span><span class="op">.</span><span class="nam">as_dict</span><span class="op">(</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t81" class="mis show_mis"><span class="n"><a href="#t81">81</a></span><span class="t">            <span class="key">return</span> <span class="nam">response</span>&nbsp;</span><span class="r"></span></p>
    <p id="t82" class="pln"><span class="n"><a href="#t82">82</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t83" class="mis show_mis"><span class="n"><a href="#t83">83</a></span><span class="t">            <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t84" class="pln"><span class="n"><a href="#t84">84</a></span><span class="t">                <span class="nam">msg</span><span class="op">=</span><span class="str">"Not enough permissions in view_delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span>&nbsp;</span><span class="r"></span></p>
    <p id="t85" class="pln"><span class="n"><a href="#t85">85</a></span><span class="t">            <span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t86" class="mis show_mis"><span class="n"><a href="#t86">86</a></span><span class="t">            <span class="nam">abort</span><span class="op">(</span><span class="nam">Unauthorized</span><span class="op">.</span><span class="nam">code</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t87" class="mis show_mis"><span class="n"><a href="#t87">87</a></span><span class="t">    <span class="key">except</span> <span class="op">(</span><span class="nam">KeyError</span><span class="op">,</span> <span class="nam">DecodeError</span><span class="op">,</span> <span class="nam">ExpiredSignatureError</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t88" class="mis show_mis"><span class="n"><a href="#t88">88</a></span><span class="t">        <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span><span class="nam">msg</span><span class="op">=</span><span class="str">"Token error in view_delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t89" class="mis show_mis"><span class="n"><a href="#t89">89</a></span><span class="t">        <span class="nam">abort</span><span class="op">(</span><span class="nam">Unauthorized</span><span class="op">.</span><span class="nam">code</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t90" class="pln"><span class="n"><a href="#t90">90</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t91" class="pln"><span class="n"><a href="#t91">91</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t92" class="run"><span class="n"><a href="#t92">92</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">"/{}/&lt;int:delivery_id>"</span><span class="op">.</span><span class="nam">format</span><span class="op">(</span><span class="nam">config</span><span class="op">.</span><span class="nam">SERVICE_NAME</span><span class="op">)</span><span class="op">,</span> <span class="nam">methods</span><span class="op">=</span><span class="op">[</span><span class="str">"PUT"</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t93" class="pln"><span class="n"><a href="#t93">93</a></span><span class="t"><span class="key">def</span> <span class="nam">update_delivery</span><span class="op">(</span><span class="nam">delivery_id</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t94" class="mis show_mis"><span class="n"><a href="#t94">94</a></span><span class="t">    <span class="key">try</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t95" class="mis show_mis"><span class="n"><a href="#t95">95</a></span><span class="t">        <span class="nam">auth_header</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">headers</span><span class="op">[</span><span class="str">"Authorization"</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t96" class="mis show_mis"><span class="n"><a href="#t96">96</a></span><span class="t">        <span class="nam">decoded_token</span> <span class="op">=</span> <span class="nam">BusinessLogic</span><span class="op">.</span><span class="nam">get_instance</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">decrypt_jwt</span><span class="op">(</span><span class="nam">auth_header</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t97" class="mis show_mis"><span class="n"><a href="#t97">97</a></span><span class="t">        <span class="key">if</span> <span class="str">"U_DELIVERY"</span> <span class="key">in</span> <span class="nam">decoded_token</span><span class="op">[</span><span class="str">"perms"</span><span class="op">]</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t98" class="mis show_mis"><span class="n"><a href="#t98">98</a></span><span class="t">            <span class="key">if</span> <span class="nam">request</span><span class="op">.</span><span class="nam">headers</span><span class="op">[</span><span class="str">"Content-Type"</span><span class="op">]</span> <span class="op">!=</span> <span class="str">"application/json"</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t99" class="mis show_mis"><span class="n"><a href="#t99">99</a></span><span class="t">                <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t100" class="pln"><span class="n"><a href="#t100">100</a></span><span class="t">                    <span class="nam">msg</span><span class="op">=</span><span class="str">"Unsupported media type in update_delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span>&nbsp;</span><span class="r"></span></p>
    <p id="t101" class="pln"><span class="n"><a href="#t101">101</a></span><span class="t">                <span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t102" class="mis show_mis"><span class="n"><a href="#t102">102</a></span><span class="t">                <span class="nam">abort</span><span class="op">(</span><span class="nam">UnsupportedMediaType</span><span class="op">.</span><span class="nam">code</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t103" class="mis show_mis"><span class="n"><a href="#t103">103</a></span><span class="t">            <span class="nam">content</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">json</span>&nbsp;</span><span class="r"></span></p>
    <p id="t104" class="mis show_mis"><span class="n"><a href="#t104">104</a></span><span class="t">            <span class="nam">status</span> <span class="op">=</span> <span class="nam">content</span><span class="op">[</span><span class="str">"status"</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t105" class="mis show_mis"><span class="n"><a href="#t105">105</a></span><span class="t">            <span class="nam">delivery_dict</span> <span class="op">=</span> <span class="nam">BusinessLogic</span><span class="op">.</span><span class="nam">get_instance</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">update_delivery</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t106" class="pln"><span class="n"><a href="#t106">106</a></span><span class="t">                <span class="nam">delivery_id</span><span class="op">,</span> <span class="nam">status</span>&nbsp;</span><span class="r"></span></p>
    <p id="t107" class="pln"><span class="n"><a href="#t107">107</a></span><span class="t">            <span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t108" class="mis show_mis"><span class="n"><a href="#t108">108</a></span><span class="t">            <span class="key">if</span> <span class="nam">delivery_dict</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t109" class="mis show_mis"><span class="n"><a href="#t109">109</a></span><span class="t">                <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span><span class="nam">msg</span><span class="op">=</span><span class="str">" Not found in update_delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t110" class="mis show_mis"><span class="n"><a href="#t110">110</a></span><span class="t">                <span class="nam">abort</span><span class="op">(</span><span class="nam">NotFound</span><span class="op">.</span><span class="nam">code</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t111" class="mis show_mis"><span class="n"><a href="#t111">111</a></span><span class="t">            <span class="key">if</span> <span class="nam">status</span> <span class="op">==</span> <span class="nam">Delivery</span><span class="op">.</span><span class="nam">STATUS_FINISHED</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t112" class="mis show_mis"><span class="n"><a href="#t112">112</a></span><span class="t">                <span class="nam">update_order</span><span class="op">(</span><span class="nam">delivery_dict</span><span class="op">[</span><span class="str">"order_id"</span><span class="op">]</span><span class="op">,</span> <span class="str">"Delivered"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t113" class="pln"><span class="n"><a href="#t113">113</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t114" class="mis show_mis"><span class="n"><a href="#t114">114</a></span><span class="t">            <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span><span class="nam">msg</span><span class="op">=</span><span class="str">"PUT /delivery/&lt;int:delivery_id>"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">DEBUG</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t115" class="mis show_mis"><span class="n"><a href="#t115">115</a></span><span class="t">            <span class="nam">response</span> <span class="op">=</span> <span class="nam">jsonify</span><span class="op">(</span><span class="nam">delivery_dict</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t116" class="mis show_mis"><span class="n"><a href="#t116">116</a></span><span class="t">            <span class="key">return</span> <span class="nam">response</span>&nbsp;</span><span class="r"></span></p>
    <p id="t117" class="pln"><span class="n"><a href="#t117">117</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t118" class="mis show_mis"><span class="n"><a href="#t118">118</a></span><span class="t">            <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t119" class="pln"><span class="n"><a href="#t119">119</a></span><span class="t">                <span class="nam">msg</span><span class="op">=</span><span class="str">" Not enough permissions in update_delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span>&nbsp;</span><span class="r"></span></p>
    <p id="t120" class="pln"><span class="n"><a href="#t120">120</a></span><span class="t">            <span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t121" class="mis show_mis"><span class="n"><a href="#t121">121</a></span><span class="t">            <span class="nam">abort</span><span class="op">(</span><span class="nam">Unauthorized</span><span class="op">.</span><span class="nam">code</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t122" class="mis show_mis"><span class="n"><a href="#t122">122</a></span><span class="t">    <span class="key">except</span> <span class="op">(</span><span class="nam">KeyError</span><span class="op">,</span> <span class="nam">DecodeError</span><span class="op">,</span> <span class="nam">ExpiredSignatureError</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t123" class="mis show_mis"><span class="n"><a href="#t123">123</a></span><span class="t">        <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span><span class="nam">msg</span><span class="op">=</span><span class="str">"Token error in view_delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t124" class="mis show_mis"><span class="n"><a href="#t124">124</a></span><span class="t">        <span class="nam">abort</span><span class="op">(</span><span class="nam">Unauthorized</span><span class="op">.</span><span class="nam">code</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t125" class="pln"><span class="n"><a href="#t125">125</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t126" class="pln"><span class="n"><a href="#t126">126</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t127" class="run"><span class="n"><a href="#t127">127</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">"/{}/order/&lt;int:order_id>"</span><span class="op">.</span><span class="nam">format</span><span class="op">(</span><span class="nam">config</span><span class="op">.</span><span class="nam">SERVICE_NAME</span><span class="op">)</span><span class="op">,</span> <span class="nam">methods</span><span class="op">=</span><span class="op">[</span><span class="str">"GET"</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t128" class="pln"><span class="n"><a href="#t128">128</a></span><span class="t"><span class="key">def</span> <span class="nam">view_order_delivery</span><span class="op">(</span><span class="nam">order_id</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t129" class="mis show_mis"><span class="n"><a href="#t129">129</a></span><span class="t">    <span class="key">try</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t130" class="mis show_mis"><span class="n"><a href="#t130">130</a></span><span class="t">        <span class="nam">auth_header</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">headers</span><span class="op">[</span><span class="str">"Authorization"</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t131" class="mis show_mis"><span class="n"><a href="#t131">131</a></span><span class="t">        <span class="nam">decoded_token</span> <span class="op">=</span> <span class="nam">BusinessLogic</span><span class="op">.</span><span class="nam">get_instance</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">decrypt_jwt</span><span class="op">(</span><span class="nam">auth_header</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t132" class="mis show_mis"><span class="n"><a href="#t132">132</a></span><span class="t">        <span class="key">if</span> <span class="str">"R_DELIVERY"</span> <span class="key">in</span> <span class="nam">decoded_token</span><span class="op">[</span><span class="str">"perms"</span><span class="op">]</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t133" class="mis show_mis"><span class="n"><a href="#t133">133</a></span><span class="t">            <span class="nam">delivery</span> <span class="op">=</span> <span class="nam">BusinessLogic</span><span class="op">.</span><span class="nam">get_instance</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">get_order_delivery</span><span class="op">(</span><span class="nam">order_id</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t134" class="mis show_mis"><span class="n"><a href="#t134">134</a></span><span class="t">            <span class="key">if</span> <span class="nam">delivery</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t135" class="mis show_mis"><span class="n"><a href="#t135">135</a></span><span class="t">                <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span><span class="nam">msg</span><span class="op">=</span><span class="str">"Not found in view_order_delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t136" class="mis show_mis"><span class="n"><a href="#t136">136</a></span><span class="t">                <span class="nam">abort</span><span class="op">(</span><span class="nam">NotFound</span><span class="op">.</span><span class="nam">code</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t137" class="mis show_mis"><span class="n"><a href="#t137">137</a></span><span class="t">            <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span><span class="nam">msg</span><span class="op">=</span><span class="str">"PUT /delivery/order/&lt;int:order_id>"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">DEBUG</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t138" class="mis show_mis"><span class="n"><a href="#t138">138</a></span><span class="t">            <span class="nam">response</span> <span class="op">=</span> <span class="nam">jsonify</span><span class="op">(</span><span class="nam">delivery</span><span class="op">.</span><span class="nam">as_dict</span><span class="op">(</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t139" class="mis show_mis"><span class="n"><a href="#t139">139</a></span><span class="t">            <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span><span class="nam">msg</span><span class="op">=</span><span class="str">"GET /delivery/order/&lt;int:order_id>"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">DEBUG</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t140" class="mis show_mis"><span class="n"><a href="#t140">140</a></span><span class="t">            <span class="key">return</span> <span class="nam">response</span>&nbsp;</span><span class="r"></span></p>
    <p id="t141" class="pln"><span class="n"><a href="#t141">141</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t142" class="mis show_mis"><span class="n"><a href="#t142">142</a></span><span class="t">            <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t143" class="pln"><span class="n"><a href="#t143">143</a></span><span class="t">                <span class="nam">msg</span><span class="op">=</span><span class="str">"Not enough permissions in view_order_delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span>&nbsp;</span><span class="r"></span></p>
    <p id="t144" class="pln"><span class="n"><a href="#t144">144</a></span><span class="t">            <span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t145" class="mis show_mis"><span class="n"><a href="#t145">145</a></span><span class="t">            <span class="nam">abort</span><span class="op">(</span><span class="nam">Unauthorized</span><span class="op">.</span><span class="nam">code</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t146" class="mis show_mis"><span class="n"><a href="#t146">146</a></span><span class="t">    <span class="key">except</span> <span class="op">(</span><span class="nam">KeyError</span><span class="op">,</span> <span class="nam">DecodeError</span><span class="op">,</span> <span class="nam">ExpiredSignatureError</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t147" class="mis show_mis"><span class="n"><a href="#t147">147</a></span><span class="t">        <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span><span class="nam">msg</span><span class="op">=</span><span class="str">"Token error in view_order_delivery"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t148" class="mis show_mis"><span class="n"><a href="#t148">148</a></span><span class="t">        <span class="nam">abort</span><span class="op">(</span><span class="nam">Unauthorized</span><span class="op">.</span><span class="nam">code</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t149" class="pln"><span class="n"><a href="#t149">149</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t150" class="pln"><span class="n"><a href="#t150">150</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t151" class="run"><span class="n"><a href="#t151">151</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">"/{}/health"</span><span class="op">.</span><span class="nam">format</span><span class="op">(</span><span class="nam">config</span><span class="op">.</span><span class="nam">SERVICE_NAME</span><span class="op">)</span><span class="op">,</span> <span class="nam">methods</span><span class="op">=</span><span class="op">[</span><span class="str">"HEAD"</span><span class="op">,</span> <span class="str">"GET"</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t152" class="run"><span class="n"><a href="#t152">152</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">route</span><span class="op">(</span><span class="str">"/health"</span><span class="op">,</span> <span class="nam">methods</span><span class="op">=</span><span class="op">[</span><span class="str">"HEAD"</span><span class="op">,</span> <span class="str">"GET"</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t153" class="pln"><span class="n"><a href="#t153">153</a></span><span class="t"><span class="key">def</span> <span class="nam">health_check</span><span class="op">(</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t154" class="mis show_mis"><span class="n"><a href="#t154">154</a></span><span class="t">    <span class="key">if</span> <span class="key">not</span> <span class="nam">BusinessLogic</span><span class="op">.</span><span class="nam">get_instance</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">get_up_status</span><span class="op">(</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t155" class="mis show_mis"><span class="n"><a href="#t155">155</a></span><span class="t">        <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span><span class="nam">msg</span><span class="op">=</span><span class="str">"Service unavailable"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t156" class="mis show_mis"><span class="n"><a href="#t156">156</a></span><span class="t">        <span class="nam">abort</span><span class="op">(</span><span class="nam">ServiceUnavailable</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t157" class="pln"><span class="n"><a href="#t157">157</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t158" class="mis show_mis"><span class="n"><a href="#t158">158</a></span><span class="t">    <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span><span class="nam">msg</span><span class="op">=</span><span class="str">"GET /health"</span><span class="op">,</span> <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">HEALTH</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t159" class="mis show_mis"><span class="n"><a href="#t159">159</a></span><span class="t">    <span class="key">return</span> <span class="str">"OK"</span>&nbsp;</span><span class="r"></span></p>
    <p id="t160" class="pln"><span class="n"><a href="#t160">160</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t161" class="pln"><span class="n"><a href="#t161">161</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t162" class="pln"><span class="n"><a href="#t162">162</a></span><span class="t"><span class="com"># Error Handling #####################################################################################################</span>&nbsp;</span><span class="r"></span></p>
    <p id="t163" class="run"><span class="n"><a href="#t163">163</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">errorhandler</span><span class="op">(</span><span class="nam">UnsupportedMediaType</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t164" class="pln"><span class="n"><a href="#t164">164</a></span><span class="t"><span class="key">def</span> <span class="nam">unsupported_media_type_handler</span><span class="op">(</span><span class="nam">e</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t165" class="mis show_mis"><span class="n"><a href="#t165">165</a></span><span class="t">    <span class="key">return</span> <span class="nam">get_jsonified_error</span><span class="op">(</span><span class="nam">e</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t166" class="pln"><span class="n"><a href="#t166">166</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t167" class="pln"><span class="n"><a href="#t167">167</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t168" class="run"><span class="n"><a href="#t168">168</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">errorhandler</span><span class="op">(</span><span class="nam">BadRequest</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t169" class="pln"><span class="n"><a href="#t169">169</a></span><span class="t"><span class="key">def</span> <span class="nam">bad_request_handler</span><span class="op">(</span><span class="nam">e</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t170" class="mis show_mis"><span class="n"><a href="#t170">170</a></span><span class="t">    <span class="key">return</span> <span class="nam">get_jsonified_error</span><span class="op">(</span><span class="nam">e</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t171" class="pln"><span class="n"><a href="#t171">171</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t172" class="pln"><span class="n"><a href="#t172">172</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t173" class="run"><span class="n"><a href="#t173">173</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">errorhandler</span><span class="op">(</span><span class="nam">NotFound</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t174" class="pln"><span class="n"><a href="#t174">174</a></span><span class="t"><span class="key">def</span> <span class="nam">resource_not_found_handler</span><span class="op">(</span><span class="nam">e</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t175" class="mis show_mis"><span class="n"><a href="#t175">175</a></span><span class="t">    <span class="key">return</span> <span class="nam">get_jsonified_error</span><span class="op">(</span><span class="nam">e</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t176" class="pln"><span class="n"><a href="#t176">176</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t177" class="pln"><span class="n"><a href="#t177">177</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t178" class="run"><span class="n"><a href="#t178">178</a></span><span class="t"><span class="op">@</span><span class="nam">app</span><span class="op">.</span><span class="nam">errorhandler</span><span class="op">(</span><span class="nam">InternalServerError</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t179" class="pln"><span class="n"><a href="#t179">179</a></span><span class="t"><span class="key">def</span> <span class="nam">server_error_handler</span><span class="op">(</span><span class="nam">e</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t180" class="mis show_mis"><span class="n"><a href="#t180">180</a></span><span class="t">    <span class="key">return</span> <span class="nam">get_jsonified_error</span><span class="op">(</span><span class="nam">e</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t181" class="pln"><span class="n"><a href="#t181">181</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t182" class="pln"><span class="n"><a href="#t182">182</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t183" class="run"><span class="n"><a href="#t183">183</a></span><span class="t"><span class="key">def</span> <span class="nam">get_jsonified_error</span><span class="op">(</span><span class="nam">e</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t184" class="mis show_mis"><span class="n"><a href="#t184">184</a></span><span class="t">    <span class="nam">logger</span><span class="op">.</span><span class="nam">print</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t185" class="pln"><span class="n"><a href="#t185">185</a></span><span class="t">        <span class="nam">str</span><span class="op">(</span><span class="op">{</span><span class="str">"error_code"</span><span class="op">:</span> <span class="nam">e</span><span class="op">.</span><span class="nam">code</span><span class="op">,</span> <span class="str">"error_message"</span><span class="op">:</span> <span class="nam">e</span><span class="op">.</span><span class="nam">description</span><span class="op">,</span> <span class="str">"request"</span><span class="op">:</span> <span class="nam">request</span><span class="op">}</span><span class="op">)</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t186" class="pln"><span class="n"><a href="#t186">186</a></span><span class="t">        <span class="nam">level</span><span class="op">=</span><span class="nam">Logger</span><span class="op">.</span><span class="nam">ERROR</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t187" class="pln"><span class="n"><a href="#t187">187</a></span><span class="t">    <span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t188" class="mis show_mis"><span class="n"><a href="#t188">188</a></span><span class="t">    <span class="key">return</span> <span class="nam">jsonify</span><span class="op">(</span><span class="op">{</span><span class="str">"error_code"</span><span class="op">:</span> <span class="nam">e</span><span class="op">.</span><span class="nam">code</span><span class="op">,</span> <span class="str">"error_message"</span><span class="op">:</span> <span class="nam">e</span><span class="op">.</span><span class="nam">description</span><span class="op">}</span><span class="op">)</span><span class="op">,</span> <span class="nam">e</span><span class="op">.</span><span class="nam">code</span>&nbsp;</span><span class="r"></span></p>
</div>
<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v5.0.4</a>,
            created at 2020-03-24 19:28
        </p>
    </div>
</div>
</body>
</html>
